/*
	PSAdobe.h
	
*/

#ifndef _H_PSAdobe
#define _H_PSAdobe

#define kPSAdobeVersion (1)

enum {	/* new PrGeneral selectors */
	getPSInfoOp = 10,
	PSIntentionsOp = 11,
	PSAdobeOp = 14,
	PSPrimaryPPDOp = 15
};

enum {	/* PSAdobeOp sub id's */
	PSnone = 0,
	PSpict2eps,			/* convert pict -> eps */
	PSFontInfo			/* get info about a font */
};

enum {	/* for printerClass field */
	kCUnknown	= 0,
	kCNone		= 1,			/* no TT possible, send type 1 version */
	kCAccept68K	= 2,			/* possible to download scaler (eexec and cexec defined) */
	kCType42	= 3				/* TT built into printer */
};

enum {	/* for includeFonts field */
	includeNoFonts = 0,
	includeAllFonts,
	includeAllBut13
};

enum {	/* for color field */
	kBlackAndWhite = 0,
	kColor,
	kCalibratedColor
};

#define kMaxPSResources (7)
#define kVMusageUnknown (-1)

struct TPSAdobe {
	short			iOpCode;
	short			iError;
	long			lReserved;
	short			subId;
	short			version;
	/* common stuff in most cases */
	OSErr			(*op)(char *p, long len);
	unsigned short	binary : 1;
	unsigned short	level2 : 1;
	
	unsigned short	reserved : 14;
	unsigned short	appFlags;
	
	union {
		struct {
			PicHandle		pict;
			Ptr 			getPicProc;
			long			includeFonts;
			StringPtr		title;
			unsigned short	unlimitedFonts : 1;
			unsigned short	textSmoothing : 1;
			unsigned short	graphicsSmoothing : 1;
			unsigned short	color : 2;
			unsigned short	fontSubstitution : 1;
			
			unsigned short	reserved : 10;
		} pict2eps;
		struct {
			short			id;
			unsigned short	style;
			Str63			psName;						/* in/out */
			unsigned char	printerClass;
			unsigned char	calcVMusage : 1;			/* in */
			
			unsigned char	postScript : 1;				/* out */
			unsigned char	hasPSOutline : 1;			/* out */
			unsigned char	trueType : 1;				/* out */
			unsigned char	multipleMaster : 1;			/* out */
			
			unsigned char	reserved : 3;
			
			unsigned short	fontClass;					/* out */
			Style			satisfied;					/* out */

			unsigned short	nResources;					/* out */
			unsigned short	resource[kMaxPSResources];	/* out */
			struct TPSAdobe **data;						/* in/out */
		} fontInfo;
		struct {
			long VMusage;								/* out */
			short count;	/* # of ref's to the resource */	/* out */
		} fromFontInfo;
	} is;
};

typedef struct TPSAdobe TPSAdobe;

#define kPSInfoVersion 1

enum {	/* typeOfSave */
	kSavePSUnknown = -1,
	kSavePSFile = 0,
	kSaveEPSBitMap,
	kSaveEPSPICT,
	kSaveEPSNoPreview
};

struct TgetPSInfo {
    short			iOpCode;
    short			iError;
    long			lReserved;
    struct TPrint**	hPrint;
	short			version;
	short			level;
	short			typeOfSave;
	unsigned short	printToFile : 1;	/* if true, typeOfSave indicates which kind of file */
	unsigned short	binary : 1;
	unsigned short	reserved : 14;		/* should be zero */
};

typedef struct TgetPSInfo TgetPSInfo;

#define kPSIntentionsVersion 1

struct TPSIntentions {
    short			iOpCode;
    short			iError;
    long			lReserved;
    struct TPrint**	hPrint;
	short			version;
	short			level;
	unsigned short	binary : 1;
	unsigned short	reserved : 15;		/* should be zero */
};

typedef struct TPSIntentions TPSIntentions;

struct TPSPrimaryPPD {
    short			iOpCode;
    short			iError;
    long			lReserved;
	short			ppdIsRealFile;
    FSSpec			ppdFile;
};

typedef struct TPSPrimaryPPD TPSPrimaryPPD;


#endif PSAdobePublic
